
// scl SE CONECTA AL PIN 22
// sda    SE CONECTA AL PIN 21
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels
#define OLED_RESET     -1
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);
//------------------------------------------ Libraries to get time from NTP Server
#include <WiFi.h>
#include <NTPClient.h>
#include <WiFiUdp.h>// 
#include <Arduino.h>
//--------------------------------------
#define LED_BUILTIN 2 // 
#define RESET   16   //
#define BTNDOWN   5    //
#define BTNUP   18   //

int delta=1;
int arriba = 0; 
int power = 0; 
int boton_old=0;
unsigned long tiempo=0;
unsigned long retardo1=0;
//-------------------------------------------------------------------parametros de la web
const char* ssid = "Teldrive_air";
const char* password = "Teldrive@1234";
const boolean hidden = false;// permite que se vea el ssid
int wifis=0; //detecta si se ha conectado algun remoto
unsigned long Millis_old=0;
IPAddress local_ip(192,168,1,1);
IPAddress gateway(192,168,1,1);
IPAddress subnet(255,255,255,0);
WiFiServer server(80);
//
//-----------------------------------TAREA 1 de led intermitente independiente de la otra
void ledintermitente( void * parameter ){
  for( ;; ){
String mensaje="WIFI ON";
if(wifis>0){
mensaje="CONNECTED";
tiempo ++;}
else{
        tiempo=0;
}
digitalWrite(LED_BUILTIN,HIGH);//notifica actividad
display.clearDisplay();
display.setTextColor(WHITE); 
    display.setTextSize(1);
    display.setCursor(10, 0);
    display.print(mensaje);
    display.setCursor(80, 0);
    display.print(tiempo);
    display.setCursor(10, 12);
    display.setTextSize(2);
 if(power==1)  {
 display.print("MOTOR ON");
 }

 if(power==0) {  
display.print("MOTOR OFF");
 }
display.setCursor(15, 30);
display.setTextSize(5);
display.print(arriba);
display.display();// dibuja el texto
delay(500);
digitalWrite(LED_BUILTIN,LOW);//notifica actividad
display.setTextColor(BLACK); 
display.setTextSize(1);
display.setCursor(10, 0);
display.print(mensaje);
 display.display();// dibuja el texto
delay(500);
//vTaskDelay(1000/portTICK_PERIOD_MS);// ejecuta la tarea cada x tiempo
Serial.println("luz intermitente");
  }
}
//----------------------------------------------------evento wifi connect/disconnect
void WiFiStationConnected(WiFiEvent_t event, WiFiEventInfo_t info){
  Serial.println("conectada");
wifis=1;
}
void WiFiStationDisconnected(WiFiEvent_t event, WiFiEventInfo_t info){
  Serial.println("desconectada");
wifis=0;
}
//************************************************************************** COMIENZA SETUP
void setup(){  
  Serial.begin(9600);
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
  pinMode(LED_BUILTIN,OUTPUT);//inicializ el led interno
  pinMode(BTNUP, INPUT);//ademas el led externo colocado 
  pinMode(BTNDOWN, INPUT);//ademas el led externo colocado 
  pinMode(RESET, INPUT);//ademas el led externo colocado 
  //-------------------para detectar conexion y desconexion wifi
  WiFi.onEvent(WiFiStationConnected, SYSTEM_EVENT_AP_STACONNECTED);
  WiFi.onEvent(WiFiStationDisconnected, SYSTEM_EVENT_AP_STADISCONNECTED);// ojo tarda en detectarlo 5 minuto
  WiFi.onEvent(WiFiStationDisconnected, SYSTEM_EVENT_ETH_DISCONNECTED);
  //----------------------------------display
display.clearDisplay();// limpia display
display.setTextColor(WHITE); 
    display.setCursor(10, 0);
    display.setTextSize(2);
    display.print("WIFI ON");
    display.setTextSize(1);
    display.setCursor(20, 30);
    display.print(ssid);
    display.display();// dibuja el texto
    delay(2000);
  // ---------------------------------------
  xTaskCreatePinnedToCore(
                    ledintermitente,          /* Task function. */
                    "Intermitente",        /* String with name of task. */
                    5000,            /* Stack size in bytes. */
                    NULL,             /* Parameter passed as input of the task */
                    1,                /* Priority of the task. */
                    NULL,               /* Task handle. */
                    CONFIG_ARDUINO_RUNNING_CORE);     /* Muy importante. */       


  //****************************************************************************************************************
  //-----------------------------------CONFIGURA wifi
  boolean result1 = WiFi.softAPConfig (local_ip, gateway, subnet);
  if(result1 == true)  {
  Serial.print("Soft-AP IP address = ");
  Serial.println(WiFi.softAPIP());
  }
  else  {     Serial.println("Failed!");   }
  //-----------------------------------------Activa wifi
  boolean result2 = WiFi.softAP(ssid, password,hidden);// default ip 192.168.1.1
  if(result2 == true)  {
    Serial.println("Ready");
      server.begin();
  Serial.printf("Web server started, open %s in a web browser\n", WiFi.softAPIP().toString().c_str());
  }
  else   {     Serial.println("Failed!");  }
}


//***************************************************************************COMIENZA LOOP
void loop(){
static  int buttonUP = 0; 
static int buttonPWR = 0; 
static int buttonDOWN = 0;

buttonUP = digitalRead(BTNUP);
buttonDOWN = digitalRead(BTNDOWN);
buttonPWR = digitalRead(RESET);

  unsigned long retardo=millis();
if((buttonUP == HIGH)||(buttonDOWN == HIGH)||(buttonPWR == HIGH)){
if((retardo-retardo1)<500){
  if(delta<5){delta++; }// regula los incrementos
}else{delta=1;}
    retardo1=retardo;// iguala retardos por si se pulsa otra tecla muy raopido
if(buttonUP == HIGH){
  if(( arriba < 100)&&( power == 1)){   
    arriba= arriba +delta; 
    if(arriba >100) {arriba=100;}
  } }
if (buttonDOWN == HIGH){
  if(( arriba >0)&&( power == 1)){ 
    arriba= arriba -delta;
    if(arriba <0) {arriba=0;}
    }}

if (buttonPWR == HIGH){
 if( power==1){ power=0;
 arriba=0;}else{  power=1;}
   }

wifienvia();// envia wifi constantemente
 delay(300);// imprescindible para evitar rebotes de motores
}else{
  
unsigned long currentMillis = millis();
if( currentMillis-Millis_old >2000) {  
  Millis_old=currentMillis;
  //wifienvia();// envia algo cada 2 sg
}else{
 delay(200);

}
}

}

//-------COMPRUEBA ESTADO WIFI
void wifienvia(){
if (wifis){//-------------------detecta que hay un equipo conectado via wifi
 WiFiClient client = server.available();  // wait for a client (web browser) to connect
  if (client)   {
    //Serial.println("Envia datos");
    while (client.connected()) {  // read line by line what the client (web browser) is requesting
      if (client.available())  {
        String line = client.readStringUntil('\r');// RECIBE PRIMERO DATOS (RX)
        if (line.length() == 1 && line[0] == '\n')    {
          client.println(envia_datos());  // TRANSMITE DATOS TX
          break;
        }
      }
    }
delay(1); // give the web browser time to receive the data
client.stop();    // close the connection:
  }
}else{
   Serial.println("   Quiere enviar pero NO HAY Clientes");
}
}
//---------------------------------------------
String envia_datos(){
  String htmlPage =String(arriba) + ";" + String(power)+ ";\n";
  Serial.printf("Envia Power= %d ", power);
Serial.printf(" Arriba= %d \n", arriba);
  return htmlPage;
}
